
        #version 310 es
        #pragma only_renderers glsl31 metal

        // keywords
        #pragma multi_compile VFX_COMPAT_MODE
    
        //global section
        #pragma global vs_global
        #pragma end
    
        //// attributes in vertex shader
        #pragma input attributes
        #pragma end
    
        // varyings : outputs of vertex shader ,inputs for fragment shader
        #pragma varying varyings
        highp vec4 vTex;
        highp vec4 v0;
        highp vec4 v1;
        highp vec4 v2;
        highp vec4 v3;
        highp vec4 v4;
        highp vec4 v5;
        highp vec4 v6;
        highp vec4 v7;

        #pragma end
    
        // output targets in fragment shader
        #pragma output targets
        layout(location = 0) out highp vec4 color0;
        #pragma end
    
        // vertex stage section in vertex shader
        #pragma vs attributes varyings vs_global
        precision highp float;
        precision highp sampler2D;
        precision highp sampler3D;

        //buffer 1
        #define BUFFER_WIDTH 2048
        #ifdef VFX_COMPAT_MODE
        layout(binding = 0) uniform sampler2D attributeBuffer;
        layout(binding = 1) uniform sampler2D sortBuffer;
        #else
        layout(std430, binding = 0) buffer attributeBuffer {
            uint attributeBuffer_buf[];
        };
        layout(std430, binding = 1) buffer sortBuffer {
            uint sortBuffer_buf[];
        };
        #endif
        uniform vec2 FlipbookSize;

        uniform mat4 Model;
        uniform mat4 WorldToLocal;
        uniform mat4 View;
        uniform mat4 Projection;
        uniform mat4 ModelInv;
        uniform vec4 u_WorldSpaceCameraPos;
        uniform float delta;
        uniform vec4 u_ScreenParams;
        uniform float deltatime;

        
#define VFX_PI 3.1415926538
#define VFX_PI2 6.28318530718
#define VFX_M_PI_F 3.14159265359
#define VFX_HALF_PI 1.57079632679
#define VFX_ONE_THIRD_PI 1.0471975512
#define VFX_FLT_MIN 1.175494351e-38
#define VFX_EPSILON 1e-5
uint wang_hash(uint seed)
{
    seed = (seed ^ 61u) ^ (seed >> 16u);
    seed *= 9u;
    seed = seed ^ (seed >> 4u);
    seed *= 0x27d4eb2du;
    seed = seed ^ (seed >> 15u);
    return seed;
}

uint AnotherHash(uint seed)
{
    seed = ((seed >> 16u) ^ seed) * 0x45d9f3bu;
    seed = ((seed >> 16u) ^ seed) * 0x45d9f3bu;
    seed = (seed >> 16u) ^ seed;
    return seed;
}

float Rand(inout uint seed)
{
    seed = 0x0019660du * seed + 0x3c6ef35fu;
    float t = uintBitsToFloat((seed >> 9u) | 0x3f800000u);
    return t - 1.0f;
}
    
vec2 Rand2(inout uint seed)
{
    return vec2(Rand(seed), Rand(seed));
}

vec3 Rand3(inout uint seed)
{
    return vec3(Rand(seed), Rand(seed), Rand(seed));
}

float random(inout uint seed, float A, float B)
{
    float rand = Rand(seed);
    return mix(A, B, rand);
}

vec3 random3(inout uint seed, vec3 A, vec3 B)
{
    vec3 rand3 = Rand3(seed);
    return mix(A, B, rand3);
}

vec3 VFXSafeNormalize(vec3 v)
{
    float sqrLength = max(VFX_FLT_MIN,dot(v,v));
    return v * inversesqrt(sqrLength);
}

vec3 HUEtoRGB(float H)
{
    float R = abs(H * 6.0 - 3.0) - 1.0;
    float G = 2.0 - abs(H * 6.0 - 2.0);
    float B = 2.0 - abs(H * 6.0 - 4.0);
    return clamp(vec3(R,G,B), 0.0, 1.0);
}

vec3 RGBtoHCV(vec3 RGB)
{
    vec4 P = (RGB.g < RGB.b) ? vec4(RGB.bg, -1.0, 2.0/3.0) : vec4(RGB.gb, 0.0, -1.0/3.0);
    vec4 Q = (RGB.r < P.x) ? vec4(P.xyw, RGB.r) : vec4(RGB.r, P.yzx);
    float C = Q.x - min(Q.w, Q.y);
    float H = abs((Q.w - Q.y) / (6.0 * C + 1e-10) + Q.z);
    return vec3(H, C, Q.x);
}

vec3 RGBtoHSV(vec3 RGB)
{
    vec3 HCV = RGBtoHCV(RGB);
    float S = HCV.y / (HCV.z + 1e-10);
    return vec3(HCV.x, S, HCV.z);
}

vec3 HSVtoRGB(vec3 HSV)
{
    return ((HUEtoRGB(HSV.x) - 1.0) * HSV.y + 1.0) * HSV.z;
}

vec3 quintic(vec3 x)
{
    return x * x * x * (x * (x * 6.0 - 15.0) + 10.0);
}

float hash(vec3 v)
{
    float HASHSCALE = 0.1031;
    v = fract(v * HASHSCALE);
    v += dot(v, v.yzx + 19.19);
    return fract((v.x + v.y) * v.z);
}

float noise01(float x, float y, float z)
{
    // Gradients
    vec3 PerlinNoise_Gradients[12];
    PerlinNoise_Gradients[0] = vec3(1, 1, 0);
    PerlinNoise_Gradients[1] = vec3(-1, 1, 0);
    PerlinNoise_Gradients[2] = vec3(1, -1, 0);
    PerlinNoise_Gradients[3] = vec3(-1, -1, 0);
    PerlinNoise_Gradients[4] = vec3(1, 0, 1);
    PerlinNoise_Gradients[6] = vec3(1, 0, -1);
    PerlinNoise_Gradients[7] = vec3(-1, 0, -1);
    PerlinNoise_Gradients[8] = vec3(0, 1, 1);
    PerlinNoise_Gradients[9] = vec3(0, -1, 1);
    PerlinNoise_Gradients[10] = vec3(0, 1, -1);
    PerlinNoise_Gradients[11] = vec3(0, -1, -1);

    vec3 p = floor(vec3(x, y, z));
    vec3 t = vec3(x, y, z) - p;
    vec3 f = quintic(t);
    vec3 v0 = p + vec3(0.0, 0.0, 0.0);
    vec3 v1 = p + vec3(1.0, 0.0, 0.0);
    vec3 v2 = p + vec3(0.0, 1.0, 0.0);
    vec3 v3 = p + vec3(1.0, 1.0, 0.0);
    vec3 v4 = v0 + vec3(0.0, 0.0, 1.0);
    vec3 v5 = v1 + vec3(0.0, 0.0, 1.0);
    vec3 v6 = v2 + vec3(0.0, 0.0, 1.0);
    vec3 v7 = v3 + vec3(0.0, 0.0, 1.0);

    int g0Index = int(hash(v0) * 12.0);
    int g1Index = int(hash(v1) * 12.0);
    int g2Index = int(hash(v2) * 12.0);
    int g3Index = int(hash(v3) * 12.0);
    int g4Index = int(hash(v4) * 12.0);
    int g5Index = int(hash(v5) * 12.0);
    int g6Index = int(hash(v6) * 12.0);
    int g7Index = int(hash(v7) * 12.0);
    vec3 g0 = PerlinNoise_Gradients[g0Index];
    vec3 g1 = PerlinNoise_Gradients[g1Index];
    vec3 g2 = PerlinNoise_Gradients[g2Index];
    vec3 g3 = PerlinNoise_Gradients[g3Index];
    vec3 g4 = PerlinNoise_Gradients[g4Index];
    vec3 g5 = PerlinNoise_Gradients[g5Index];
    vec3 g6 = PerlinNoise_Gradients[g6Index];
    vec3 g7 = PerlinNoise_Gradients[g7Index];

    return mix(
        mix(
            mix(dot(g0, t - vec3(0.0, 0.0, 0.0)), dot(g1, t - vec3(1.0, 0.0, 0.0)), f.x),
            mix(dot(g2, t - vec3(0.0, 1.0, 0.0)), dot(g3, t - vec3(1.0, 1.0, 0.0)), f.x),
            f.y
        ),
        mix(
            mix(dot(g4, t - vec3(0.0, 0.0, 1.0)), dot(g5, t - vec3(1.0, 0.0, 1.0)), f.x),
            mix(dot(g6, t - vec3(0.0, 1.0, 1.0)), dot(g7, t - vec3(1.0, 1.0, 1.0)), f.x),
            f.y
        ),
        f.z
    );
}

float fBm(int octaves, float x, float y, float z, float Fre)
{
    float amplitude = 1.0;
    float frequency = Fre;
    float result = 0.0;
    float totalAmplitude = 0.0;
    
    for (int i = 0; i < octaves; i++) {
        vec3 pos = frequency * vec3(x, y, z);
        result = result + amplitude * noise01(pos.x, pos.y, pos.z);
        totalAmplitude = totalAmplitude + amplitude;
        amplitude = amplitude / 2.0;
        frequency = frequency * 2.0;
    }
    result = result / totalAmplitude;
    return result;
}

vec3 curlNoise(vec3 oldPos, float NoiseScale, float Frequency, int Octaves)
{
    float ParticleZoneSize = 5.0;
    float halfZone = ParticleZoneSize / 2.0;
    // Get noise value
    float eps = 0.0001;
    vec3 uvy = (oldPos + vec3(halfZone, halfZone, halfZone)) / ParticleZoneSize;
    uvy = uvy * NoiseScale;

    vec3 curl = vec3(0.0, 0.0, 0.0);
    float n = 0.0, a = 0.0, b = 0.0;
    float o = fBm(Octaves, uvy.x, uvy.y, uvy.z, Frequency);

    n = fBm(Octaves, uvy.x, uvy.y - eps, uvy.z, Frequency);
    a = (o - n) / eps;
    n = fBm(Octaves, uvy.x, uvy.y, uvy.z - eps, Frequency);
    b = (o - n) / eps;
    curl.x = a - b;

    n = fBm(Octaves, uvy.x, uvy.y, uvy.z - eps, Frequency);
    a = (o - n) / eps;
    n = fBm(Octaves, uvy.x - eps, uvy.y, uvy.z, Frequency);
    b = (o - n) / eps;
    curl.y = a - b;

    n = fBm(Octaves, uvy.x - eps, uvy.y, uvy.z, Frequency);
    a = (o - n) / eps;
    n = fBm(Octaves, uvy.x, uvy.y - eps, uvy.z, Frequency);
    b = (o - n) / eps;
    curl.z = a - b;

    return curl * NoiseScale * 0.01;
}

void Orient_4(inout vec3 axisX, inout vec3 axisY, inout vec3 axisZ, mat4 viewRot) /*mode:FaceCameraPlane axes:ZY */
{
    axisX = vec3(viewRot[0].x, viewRot[1].x, viewRot[2].x);
    axisY = vec3(viewRot[0].y, viewRot[1].y, viewRot[2].y);
    axisZ = vec3(viewRot[0].z, viewRot[1].z, viewRot[2].z);
}

mat3 GetScaleMatrix(vec3 scale)
{
    return mat3(scale.x,    0.0,          0.0,
                    0.0,          scale.y,    0.0,
                    0.0,          0.0,          scale.z);
}

mat3 GetEulerMatrix(vec3 angles)
{
    vec3 s,c;
    s = sin(angles);
    c = cos(angles);

    return transpose(mat3(c.y * c.z + s.x * s.y * s.z,    c.z * s.x * s.y - c.y * s.z,    c.x * s.y,
                    c.x * s.z,                      c.x * c.z,                      -s.x,
                    -c.z * s.y + c.y * s.x * s.z,   c.y * c.z * s.x + s.y * s.z,    c.x * c.y));
}
    
mat4 GetElementToVFXMatrix(vec3 axisX,vec3 axisY,vec3 axisZ,mat3 rot,vec3 pivot,vec3 size,vec3 pos)
{
    mat3 rotAndScale = GetScaleMatrix(size);
    rotAndScale = rotAndScale * rot;
    rotAndScale = rotAndScale * transpose(mat3(axisX,axisY,axisZ));
    pos -= (pivot * rotAndScale);
    return transpose(mat4(
        vec4(rotAndScale[0],pos.x),
        vec4(rotAndScale[1],pos.y),
        vec4(rotAndScale[2],pos.z),
        vec4(0.0,0.0,0.0,1.0)));
}

mat4 GetElementToVFXMatrix(vec3 axisX,vec3 axisY,vec3 axisZ,vec3 angles,vec3 pivot,vec3 size,vec3 pos)
{
    mat3 rot = GetEulerMatrix(angles);
    return GetElementToVFXMatrix(axisX,axisY,axisZ,rot,pivot,size,pos);
}

vec2 ParticleScreenUV(vec3 position, vec3 size, vec3 pivot, vec3 angle, uint inWorldSpace, mat4 model, mat4 view, mat4 projection) {
  vec3 worldPos = (model * vec4(position, 1.0)).xyz;
  vec3 axisX = vec3(1.0, 0.0, 0.0);
  vec3 axisY = vec3(0.0, 1.0, 0.0);
  vec3 axisZ = vec3(0.0, 0.0, 1.0);

  axisX = vec3(view[0].x, view[1].x, view[2].x);
  axisY = vec3(view[0].y, view[1].y, view[2].y);
  axisZ = vec3(view[0].z, view[1].z, view[2].z);
  // Orient_4(axisX, axisY, axisZ, view);
  mat4 elementToVFX = GetElementToVFXMatrix(
                      axisX,
                      axisY,
                      axisZ,
                      angle,
                      pivot,
                      size,
                      position);
  vec3 posInWorld = position;
  if(inWorldSpace == 0u){
      posInWorld = (model * elementToVFX * vec4(0.0, 0.0, 0.0, 1.0)).xyz;
  } else {
      posInWorld = (elementToVFX * vec4(0.0, 0.0, 0.0,    1.0)).xyz;
  }
  vec4 clipPos = projection * view * vec4(posInWorld, 1.0);
  vec3 ndcPos = clipPos.xyz / clipPos.w;
  vec2 screenUV = (ndcPos.xy + vec2(1.0)) * 0.5;
  return screenUV;
}

vec3 radians3(vec3 degree)
{
    return vec3(radians(degree.x), radians(degree.y), radians(degree.z));
}


mat4 GetModelMatrix(vec3 eulerRotation, vec3 translation, float flag)
{
    vec3 s, c;
    s = sin(eulerRotation);
    c = cos(eulerRotation);
    mat4 Rx;
    Rx[0] = vec4(1.0, 0.0, 0.0, 0.0);
    Rx[1] = vec4(0.0, c.x, s.x, 0.0);
    Rx[2] = vec4(0.0, -s.x, c.x, 0.0);
    Rx[3] = vec4(0.0, 0.0, 0.0, 1.0);
    mat4 Ry;
    Ry[0] = vec4(c.y, 0.0, s.y, 0.0);
    Ry[1] = vec4(0.0, 1.0, 0.0, 0.0);
    Ry[2] = vec4(-s.y, 0.0, c.y, 0.0);
    Ry[3] = vec4(0.0, 0.0, 0.0, 1.0);
    mat4 Rz;
    Rz[0] = vec4(c.z, s.z, 0.0, 0.0);
    Rz[1] = vec4(-s.z, c.z, 0.0, 0.0);
    Rz[2] = vec4(0.0, 0.0, 1.0, 0.0);
    Rz[3] = vec4(0.0, 0.0, 0.0, 1.0);
    mat4 Rw;
    Rw[0] = vec4(1.0, 0.0, 0.0, 0.0);
    Rw[1] = vec4(0.0, 1.0, 0.0, 0.0);
    Rw[2] = vec4(0.0, 0.0, 1.0, 0.0);
    Rw[3] = vec4(-translation.x, -translation.y, -translation.z, 1.0);
    if (flag <= 0.0) return Rw * Rx * Ry * Rz;
    return Rz * Ry * Rx * Rw;
}

mat4 GetTransformInvMatrix(vec3 angles,vec3 scale,vec3 pos)
{
    mat3 invrotAndScale = GetScaleMatrix(1.0/scale);
    mat3 invrot = GetEulerMatrix(-angles);
    invrotAndScale = invrot * invrotAndScale;
    mat4 inv = mat4(
        vec4(invrotAndScale[0],0),
        vec4(invrotAndScale[1],0),
        vec4(invrotAndScale[2],0),
        vec4(0,0,0,1));
    mat4 invpos = mat4(
        vec4(1.0,0,0,-pos.x),
        vec4(0,1.0,0,-pos.y),
        vec4(0,0,1,-pos.z),
        vec4(0,0,0,1));
    return transpose(invpos * inv);
}
    
mat4 GetTransformMatrix(vec3 angles,vec3 scale,vec3 pos)
{
    mat3 rotAndScale = GetScaleMatrix(scale);
    mat3 rot = GetEulerMatrix(angles);
    rotAndScale = rotAndScale * rot;
    return transpose(mat4(
        vec4(rotAndScale[0],pos.x),
        vec4(rotAndScale[1],pos.y),
        vec4(rotAndScale[2],pos.z),
        vec4(0,0,0,1)));
}
  
        
        vec2 GetSubUV(int iflipbookIndex, vec2 uv, ivec2 idim, vec2 invDim)
        {
            ivec2 tile;
            tile.y = idim.y - (iflipbookIndex / idim.x) - 1;
            tile.x = iflipbookIndex - idim.x * tile.y;
            return (vec2(tile.x, tile.y) + uv) * invDim;
        }
    
        vec4 GetUVData(vec2 flipbookSize, vec2 invFlipbookSize, vec2 uv, float texIndex) // with flipbooks
        {
            uv = vec2(uv.x, 1.0 - uv.y);
            vec4 data;
            ivec2 iflipbookSize = ivec2(flipbookSize.x, flipbookSize.y);
            int flipbookLength = iflipbookSize.x * iflipbookSize.y;
            int texIndex0 = int(floor(texIndex));
            int texIndex1 = int( ceil(texIndex));
            texIndex0 = texIndex0 - flipbookLength * (texIndex0 / flipbookLength);
            texIndex1 = texIndex1 - flipbookLength * (texIndex1 / flipbookLength);
            data.xy = GetSubUV(texIndex0, uv, iflipbookSize, invFlipbookSize);
            data.zw = GetSubUV(texIndex1, uv, iflipbookSize, invFlipbookSize);
            return data;
        }
    
        #ifdef VFX_COMPAT_MODE
        float READ_BUFFER(sampler2D buf, int index)
        {
            return texelFetch(buf, ivec2(index % BUFFER_WIDTH, index / BUFFER_WIDTH), 0).r;
        }
        #endif
        void SetFlipbookSize(vec2 FlipbookSize, inout vec2 flipbookSize)
{
 flipbookSize = FlipbookSize.xy;
}


        #pragma end

        // fragment stage section in fragment shader
        #pragma fs varyings targets
        precision mediump float;
        precision mediump sampler2D;
        precision mediump sampler3D;  
        uniform sampler2D Map0;
        uniform sampler2D MainTexture;
void SetMainTexture(sampler2D MainTexture, inout vec2 uv, inout vec4 color, inout vec4 outputColor)
{
outputColor.rgba = texture(MainTexture, uv).rgba * color.rgba;
}


        #pragma end

        void vertex()
        {
            mat4 localToWorld = Model;
            mat4 worldToLocal = WorldToLocal;
            mat4 viewMatrix = View;
            mat4 projectionMatrix = Projection;
            vec3 cameraPos = u_WorldSpaceCameraPos.xyz;
            vec2 tex_cord = vec2(float(uint(gl_VertexID) & 1u),float((uint(gl_VertexID) & 2u)>>1));
            
            vec2 vOffsets = (tex_cord - 0.5) * 2.0;
            vOffsets.y = -vOffsets.y;
            uint particleIdx = uint(gl_VertexID / 4);
            int index_c = gl_VertexID / 4;
            index_c = index_c << 6;
        #ifdef VFX_COMPAT_MODE
            vec3 position = vec3(READ_BUFFER(attributeBuffer, index_c), READ_BUFFER(attributeBuffer, index_c + 1), READ_BUFFER(attributeBuffer, index_c + 2));
            vec3 velocity = vec3(READ_BUFFER(attributeBuffer, index_c + 4), READ_BUFFER(attributeBuffer, index_c + 5), READ_BUFFER(attributeBuffer, index_c + 6));
            vec3 direction = vec3(READ_BUFFER(attributeBuffer, index_c + 7), READ_BUFFER(attributeBuffer, index_c + 8), READ_BUFFER(attributeBuffer, index_c + 9));
            float lifetime = READ_BUFFER(attributeBuffer, index_c + 10);
            float age = READ_BUFFER(attributeBuffer, index_c + 11);
            uint alive = floatBitsToUint(READ_BUFFER(attributeBuffer, index_c + 12));
            vec3 color = vec3(READ_BUFFER(attributeBuffer, index_c + 14), READ_BUFFER(attributeBuffer, index_c + 15), READ_BUFFER(attributeBuffer, index_c + 16));
            float alpha = READ_BUFFER(attributeBuffer, index_c + 17);
            vec4 customAttribute = vec4(
                READ_BUFFER(attributeBuffer, index_c + 13),
                READ_BUFFER(attributeBuffer, index_c + 18),
                READ_BUFFER(attributeBuffer, index_c + 30),
                READ_BUFFER(attributeBuffer, index_c + 31)
            );
            vec3 targetPosition = vec3(READ_BUFFER(attributeBuffer, index_c + 19), READ_BUFFER(attributeBuffer, index_c + 20), READ_BUFFER(attributeBuffer, index_c + 21));
            vec3 size = vec3(READ_BUFFER(attributeBuffer, index_c + 22), READ_BUFFER(attributeBuffer, index_c + 23), READ_BUFFER(attributeBuffer, index_c + 24));
            vec3 scale = vec3(READ_BUFFER(attributeBuffer, index_c + 41), READ_BUFFER(attributeBuffer, index_c + 42), READ_BUFFER(attributeBuffer, index_c + 43));
            uint seed = floatBitsToUint(READ_BUFFER(attributeBuffer, index_c + 3));
            float texIndex = READ_BUFFER(attributeBuffer, index_c + 32);
            float mass = READ_BUFFER(attributeBuffer, index_c + 33);
            vec3 pivot = vec3(
              READ_BUFFER(attributeBuffer, index_c + 34),
              READ_BUFFER(attributeBuffer, index_c + 35),
              READ_BUFFER(attributeBuffer, index_c + 36));
            uint particleId = floatBitsToUint(READ_BUFFER(attributeBuffer, index_c + 37));
            vec3 angle = vec3(
              READ_BUFFER(attributeBuffer, index_c + 38),
              READ_BUFFER(attributeBuffer, index_c + 39),
              READ_BUFFER(attributeBuffer, index_c + 40));
            uint inWorldSpace = floatBitsToUint(READ_BUFFER(attributeBuffer, index_c + 44));
            uint originalParticleIdx = floatBitsToUint(READ_BUFFER(attributeBuffer, index_c + 45));
        #else
            vec3 position = vec3(uintBitsToFloat(attributeBuffer_buf[index_c]), uintBitsToFloat(attributeBuffer_buf[index_c + 1]), uintBitsToFloat(attributeBuffer_buf[index_c + 2]));
            vec3 velocity = vec3(uintBitsToFloat(attributeBuffer_buf[index_c + 4]), uintBitsToFloat(attributeBuffer_buf[index_c + 5]), uintBitsToFloat(attributeBuffer_buf[index_c + 6]));
            vec3 direction = vec3(uintBitsToFloat(attributeBuffer_buf[index_c + 7]), uintBitsToFloat(attributeBuffer_buf[index_c + 8]), uintBitsToFloat(attributeBuffer_buf[index_c + 9]));
            float lifetime = uintBitsToFloat(attributeBuffer_buf[index_c + 10]);
            float age = uintBitsToFloat(attributeBuffer_buf[index_c + 11]);
            uint alive = attributeBuffer_buf[index_c + 12];
            vec3 color = vec3(uintBitsToFloat(attributeBuffer_buf[index_c + 14]), uintBitsToFloat(attributeBuffer_buf[index_c + 15]), uintBitsToFloat(attributeBuffer_buf[index_c + 16]));
            float alpha = uintBitsToFloat(attributeBuffer_buf[index_c + 17]);
            vec4 customAttribute = vec4(
                uintBitsToFloat(attributeBuffer_buf[index_c + 13]),
                uintBitsToFloat(attributeBuffer_buf[index_c + 18]),
                uintBitsToFloat(attributeBuffer_buf[index_c + 30]),
                uintBitsToFloat(attributeBuffer_buf[index_c + 31])
            );
            vec3 targetPosition = vec3(uintBitsToFloat(attributeBuffer_buf[index_c + 19]), uintBitsToFloat(attributeBuffer_buf[index_c + 20]), uintBitsToFloat(attributeBuffer_buf[index_c + 21]));
            vec3 size = vec3(uintBitsToFloat(attributeBuffer_buf[index_c + 22]), uintBitsToFloat(attributeBuffer_buf[index_c + 23]), uintBitsToFloat(attributeBuffer_buf[index_c + 24]));
            vec3 scale = vec3(uintBitsToFloat(attributeBuffer_buf[index_c + 41]), uintBitsToFloat(attributeBuffer_buf[index_c + 42]), uintBitsToFloat(attributeBuffer_buf[index_c + 43]));
            uint seed = attributeBuffer_buf[index_c + 3];
            float texIndex = uintBitsToFloat(attributeBuffer_buf[index_c + 32]);
            float mass = uintBitsToFloat(attributeBuffer_buf[index_c + 33]);
            vec3 pivot = vec3(
              uintBitsToFloat(attributeBuffer_buf[index_c + 34]),
              uintBitsToFloat(attributeBuffer_buf[index_c + 35]),
              uintBitsToFloat(attributeBuffer_buf[index_c + 36])
            );
            uint particleId = attributeBuffer_buf[index_c + 37];
            vec3 angle = vec3(
              uintBitsToFloat(attributeBuffer_buf[index_c + 38]),
              uintBitsToFloat(attributeBuffer_buf[index_c + 39]),
              uintBitsToFloat(attributeBuffer_buf[index_c + 40])
            );
            uint inWorldSpace = attributeBuffer_buf[index_c + 44];
            uint originalParticleIdx = attributeBuffer_buf[index_c + 45];
        #endif
            vec4 quaternion0 = vec4(0.0, 0.0, 0.0, 1.0);
            vec3 worldPos = (localToWorld * vec4(position, 1.0)).xyz;
            vec3 axisX = vec3(1.0, 0.0, 0.0);
            vec3 axisY = vec3(0.0, 1.0, 0.0);
            vec3 axisZ = vec3(0.0, 0.0, 1.0);
            //orient to camera
            Orient_4(axisX, axisY, axisZ, View);

            vec2 flipbookSize = vec2(1.0, 1.0);
            vec2 uv = vec2(0.0);
            vec2 uv1 = vec2(0.0);
        
                {

    SetFlipbookSize(FlipbookSize, flipbookSize);
}


        if(alive != uint(0))
        {
          //flipblook
          vec2 invFlipbookSize = 1.0 / flipbookSize;
          vec4 uvData = GetUVData(flipbookSize, invFlipbookSize, tex_cord, texIndex);
          uv = uvData.xy;
          uv1 = uvData.zw;
          size *= scale;
            mat4 elementToVFX = GetElementToVFXMatrix(
                        axisX,
                        axisY,
                        axisZ,
                        angle,
                        pivot,
                        size,
                        position);
            mat3 offsetToVFX = mat3(axisX,axisY,axisZ) * transpose(GetEulerMatrix(angle)) * GetScaleMatrix(size.xyz);
            vec3 offsetInWorld = offsetToVFX * vec3(vOffsets, 0.0);
            vec3 posInWorld = position;
            if(inWorldSpace == 0u){
              posInWorld = (Model * elementToVFX * vec4(0.0, 0.0, 0.0, 1.0)).xyz;
            } else {
              posInWorld = (elementToVFX * vec4(0.0, 0.0, 0.0, 1.0)).xyz;
            }
            vec4 clipPos = Projection * View * vec4(posInWorld + offsetInWorld, 1.0);
            gl_Position = clipPos;
            vec3 ndcPos = clipPos.xyz / clipPos.w;
            vec2 screenUV = (ndcPos.xy + vec2(1.0)) * 0.5;
            vTex = vec4(uv.x, uv.y, uv1.x, uv1.y);
            v0.xyz = color;
            v0.w = alpha;
            v1.xyz = position;
            v1.w = lifetime;
            v2.xyz = velocity;
            v2.w = age;
            v3 = customAttribute;
            v4.xyz = targetPosition;
            v4.w = mass;
            v5.xyz = size;
            v5.w = texIndex;
            v6.xyz = direction;
            v7.xy = screenUV;
        }else
        {
            gl_Position = vec4(0.0, 0.0,0.0,1.0);
            vTex.xy = tex_cord;
            vTex.zw = vec2(0.0);
            v0 = vec4(0.0);
            v1 = vec4(0.0);
            v2 = vec4(0.0);
            v3 = vec4(0.0);
            v4 = vec4(0.0);
            v5 = vec4(0.0);
            v6 = vec4(0.0);
            v7 = vec4(0.0);
        }
    }

    void fragment()
    {
        vec3 position = v1.xyz;
        float lifetime = v1.w;
        vec2 uv = vTex.xy;
        vec2 uv1 = vTex.zw;
        vec4 color = v0;
        float alpha = color.a;
        vec3 velocity = v2.xyz;
        float age = v2.w;
        vec4 customAttribute = v3;
        vec3 targetPosition = v4.xyz;
        float mass = v4.w;
        vec3 size = v5.xyz;
        float texIndex = v5.w;
        vec3 direction = v6.xyz;
        vec2 screenUV = v7.xy;
        vec4 outputColor = color;
                {

    SetMainTexture(MainTexture, uv, color, outputColor);
}


          outputColor.xyz = outputColor.xyz * outputColor.a;
          color0 = outputColor;
    }
        